/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

(function(window) {

function createCheckerOrt(x1, y1, x2, y2) {
    return function() {
        if (!this.pfeile.length)
            return 'Zeichne zuerst einen Pfeil ein, der vom Gegenstand zum virtuellen Bild zeigt…';
        const lastPfeil = this.pfeile[this.pfeile.length - 1];
//console.log({ x1: lastPfeil.x1, y1: lastPfeil.y1, x2: lastPfeil.x2, y2: lastPfeil.y2 });return true;
        return (lastPfeil.x1 == x1 && lastPfeil.y1 == y1 && lastPfeil.x2 == x2 && lastPfeil.y2 == y2);
    }
}

const LEVELS = [
    {
        "task": "<p>Der Pfeil zeigt, in welcher Richtung Licht auf die dünne Linse fällt. Zeichne den kompletten Verlauf des Lichts nach der Linse (von der Linsenmitte bis zum Rand des karrierten Bereichs) als Pfeil ein.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss der gesuchte Pfeil sein.</p>",
        "shadows": [
            { type: 'image', src: 'szenario1.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(50, 25, 100, 50)
    },
    {
        "task": "<p>Der Pfeil zeigt, in welcher Richtung Licht auf die dünne Linse fällt. Zeichne den kompletten Verlauf des Lichts nach der Linse (von der Linsenmitte bis zum Rand des karrierten Bereichs) als Pfeil ein.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss der gesuchte Pfeil sein.</p>",
        "shadows": [
            { type: 'image', src: 'szenario2.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(50, 20, 100, 20)
    },
    {
        "task": "<p>Der Pfeil zeigt, in welcher Richtung Licht auf die dünne Linse fällt. Zeichne den kompletten Verlauf des Lichts nach der Linse (von der Linsenmitte bis zum Rand des karrierten Bereichs) als Pfeil ein.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss der gesuchte Pfeil sein.</p>",
        "shadows": [
            { type: 'image', src: 'szenario3.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(50, 30, 20, 60)
    }
];

window.karokonstruktionTask = {
    levels: LEVELS
};
})(window);
