/**
* Simulations-Aufgaben verwalten
*/
function ConstructionTask(
    arrTasks
) {
    var self = this;
    this.establish();
    this.tasks = arrTasks;
    this.levellist = new Levelliste(document.body, document.body.firstChild);
    this.msgPlaceGeneral = new ScoTools.MessagePlace(true);
    this.msgPlaceGeneral.insertThisBefore(document.body.firstChild);
    this.msgPlace = new ScoTools.MessagePlace();
    this.msgPlace.insertThisBefore(document.body.firstChild);
    this.levellist.count = arrTasks.length;
    this.levellist.onchange = function(level) { self._startLevel(level); };
    this.nodeTask = document.getElementsByClassName('auftrag')[0];
    this.nodeBeforeMsg = this.nodeTask.nextSibling;
    this.simulation = new Simulation();
    this.btnBar = new BtnBar(AudioFeedbackTask.createHtml('div', document.body, null, undefined, document.getElementsByTagName('svg')[0]));
    this.btnBar.add([
        { label: 'Rückgängig', className: 'btn_undo', title: 'Letze Aktion rückgängig machen', disabled: true, onclick: function() { self.simulation.undo(); }, alwaysShowLabel: true },
        { label: 'Überprüfen', className: 'btn_check', title: 'Überprüfen, ob die Aufgabe richtig gelöst ist', alwaysShowLabel: true, onclick: function() { self.evaluate(); } }
    ]);
    this.simulation.onundochange = function(canUndo) {
        self.btnBar.items[0].disabled = !canUndo;
    }
    this.connect();
    this.levellist.done = this.getDone() ? this.tasks.length : ((this.lmslink && this.lmslink.ready && this.lmslink.score) ? this.lmslink.score : 0);
    this.levellist.active = this.getDone() ? 0 : ((this.lmslink && this.lmslink.ready && this.lmslink.score) ? this.lmslink.score : 0);
    AudioFeedbackTask.cache(true);
}
ConstructionTask.prototype = Object.create(AudioFeedbackTask.prototype);
ConstructionTask.prototype.constructor = ConstructionTask;
ConstructionTask.parent = AudioFeedbackTask;

/**
* Überprüfen, ob die aktuelle Aufgabe richtig gelöst wurde
* @return undefined
*/
ConstructionTask.prototype.evaluate = function() {
    this.clearMsg();
    const result = this.tasks[this.levellist.active].check.call(this.simulation, this);
    if (result === true) {
        this.playAudio(true);
        this.levellist.done = Math.min(Math.max(this.levellist.done, this.levellist.active + 1), this.tasks.length);
        this.saveScore(this.levellist.done, 0, this.tasks.length, (this.levellist.done >= this.tasks.length) ? 'completed' : 'incomplete');
        if (this.levellist.active < this.tasks.length + 1)
            ++this.levellist.active;
        this.showMsg('Richtig', 'msg_success');
    } else {
        this.showMsg((typeof result == 'string') ? result : 'Das passt nicht', 'msg_failed');
        this.playAudio(false);
        this.reportTime();
    }
}

/**
* Level Nummer level starten
* @return undefined
*/
ConstructionTask.prototype._startLevel = function(
    level
) {
    this.clearMsg();
    this.nodeTask.innerHTML = this.tasks[level].task ? this.tasks[level].task : '';
    this.simulation.reset(this.tasks[level].shadows, this.tasks[level].style);
}
